// A short sketch that acts a bit like a spell checker.
// First read in a word list and build a dictionary from it.
// Then read through a text file and check each word to see
// whether it's in the word list.  Strip off punctation.
// Consolidate illegal words so that each one appears just
// once.

String[] words;

boolean isWord( String wd )
{
  for( int idx = 0; idx < words.length; ++idx ) {
    if( words[idx].equals( wd ) ) {
      return true;
    }
  }
  
  return false;
}

void setup()
{
  words = loadStrings( "words.txt" );
  String[] txt = loadStrings( "input.txt" );
  
  for( int idx = 0; idx < txt.length; ++idx ) {
    String[] lwds = splitTokens( txt[idx], " \n\t,.;:?!'&-\"()" );
    for( int widx = 0; widx < lwds.length; ++widx ) {
      String wd = lwds[widx].toLowerCase();
     
      if( !isWord( wd ) ) {
        println( wd );
      }
    }
  }
}
